var glSelf;
var CashierName;
var CashierVATIN;
odoo.define('kkm_server.PaymentScreen', function(require) {
    "use strict";

    const { _t } = require('web.core');
    const PaymentScreen = require('point_of_sale.PaymentScreen');
    const Registries = require('point_of_sale.Registries');
    const NumberBuffer = require('point_of_sale.NumberBuffer');

    const PosKKMPaymentScreen = (PaymentScreen) => class extends PaymentScreen {
        setup() {
            super.setup();
            glSelf = this;
            this.UrlServer = this.env.pos.config.UrlServer;
            if (this.UrlServer=="http://localhost:5893"){this.UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
            this.User = this.env.pos.config.User;
            this.Password = this.env.pos.config.Password;
            this.InnKkm_fiscal="";
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                    this.InnKkm_fiscal=this.env.pos.config.InnKkm_fiscal;
                }
            this.InnKkm_term = "";
            if (this.env.pos.config.InnKkm_term!=undefined && this.env.pos.config.InnKkm_term!=false){
                    this.InnKkm_term=this.env.pos.config.InnKkm_term;
                }
            this.NumDevice_fiscal = this.env.pos.config.NumDevice_fiscal;
            this.NumDevice_term = this.env.pos.config.NumDevice_term;
            this.IsBarCode = this.env.pos.config.IsBarCode;
            this.DoubleReceipt = this.env.pos.config.DoubleReceipt;
        }
        /**
        * @override
        */
        async validateOrder(isForceValidate) {
            console.log('validateOrder');
            LogJS('info','validateOrder')
            var enable_kkm_server = this.env.pos.config.enable_kkm_server
            var order = this.env.pos.get_order();
            var quantities = _.map(order.get_orderlines(), function (line) {return line.quantity; });
            var plus=0;
            var minus = 0;
            var type=0;
            var NumDevice = 0
            if (this.env.pos.config.NumDevice_fiscal!=undefined && this.env.pos.config.NumDevice_fiscal!=false){
                NumDevice=this.env.pos.config.NumDevice_fiscal
            }
            var InnKkm = ''
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                InnKkm=this.env.pos.config.InnKkm_fiscal
            }
            var paymentlines = order.get_paymentlines();
            var Amount = 0;
            for (var i = 0; i < paymentlines.length; i++) {
                if (paymentlines[i].payment_method.type=="bank") {Amount = Amount + Math.abs(paymentlines[i].amount);}
            };

            if (enable_kkm_server){
                for (var i = 0; i < quantities.length; i++) {
                    if (quantities[i]>0){plus=plus+1;}
                    if (quantities[i]<0){minus=minus+1;}
                    if (plus>0 && minus==0){type=0;}
                    if (plus==0 && minus>0){type=1;}
                    if (plus>0 && minus>0){type=99;}
                }
                console.log('type',type);
                LogJS('info','type: '+type)
                if (type==99){
                    alert("Ошибка! Нельзя в одном чеке делать приход и возврат.");
                    return;
                    }
                else {
                var res = this.env.services.rpc({
                    route: '/cashier/info',
                    params: {
                        cashier_id: this.env.pos.get_cashier_user_id(),
                    },
                }, { shadow: true }).then((value) => { CashierName = value['name'];
                                                    CashierVATIN =  value['inn'];
                                                    RegisterCheck(NumDevice, type, this.IsBarCode,this.UrlServer,this.User,this.Password,order,CashierName,CashierVATIN,InnKkm,this.DoubleReceipt)
                                                    }).catch((err) => {
                                                    CashierName = this.env.pos.config.CashierName[1];
                                                    CashierVATIN = this.env.pos.config.CashierVATIN;
                                                    RegisterCheck(NumDevice, type, this.IsBarCode,this.UrlServer,this.User,this.Password,order,CashierName,CashierVATIN,InnKkm,this.DoubleReceipt)
                                                    });
                    //RegisterCheck(NumDevice, type, this.IsBarCode,this.UrlServer,this.User,this.Password,order,this.CashierName,this.CashierVATIN,InnKkm)
                }
            }
            await super.validateOrder(isForceValidate);
        }

    };
            
    Registries.Component.extend(PaymentScreen, PosKKMPaymentScreen);

    return PaymentScreen;
});
