
var glSelf;
var CashierName;
var CashierVATIN;

odoo.define('kkm_server.close_kkm', function(require) {
'use strict';

const { Gui } = require('point_of_sale.Gui');
const PosComponent = require('point_of_sale.PosComponent');
const { identifyError } = require('point_of_sale.utils');
const ProductScreen = require('point_of_sale.ProductScreen');
const { useListener } = require("@web/core/utils/hooks");
const Registries = require('point_of_sale.Registries');
const PaymentScreen = require('point_of_sale.PaymentScreen');
const { get_lot_lines } = require('point_of_sale.models');
const { remove_orderline } = require('point_of_sale.models');

// вызывает поп-ап при неверном коде ЧЗ
window.myErrorPopup = function(serverResponse) {
    // Use the Gui object here
    Gui.showPopup('ErrorPopup', {
      'title': 'Ошибка ЧЗ',
      'body': `${serverResponse} \n Данный товар будет удален из корзины.`,
    });
  };
// удаляет продукт при неверном коде ЧЗ
window.removeCurrentOrderline = function() {
    var order = glSelf.env.pos.get_order();
    var orderlines = order.get_orderlines();
    if (orderlines.length) {
        var orderline = orderlines[orderlines.length - 1];
        order.remove_orderline(orderline);
    }
};

class KKM_Close extends PosComponent {
      setup() {
          super.setup();
          useListener('click', this.onClick);
      }
      
     async onClick() {
        var self = this;
        glSelf = this;
        console.log('close_kkm');
        LogJS('info','close_kkm')
        var UrlServer = this.env.pos.config.UrlServer;
        if (UrlServer=="http://localhost:5893"){UrlServer = window.location.protocol + "//" + window.location.hostname + ":5893";}
        var User = this.env.pos.config.User;
        var Password = this.env.pos.config.Password;
        var NumDevice = 0;
        if (this.env.pos.config.NumDevice_fiscal!=undefined && this.env.pos.config.NumDevice_fiscal!=false){
                NumDevice=this.env.pos.config.NumDevice_fiscal
            }
        var InnKkm = ''
            if (this.env.pos.config.InnKkm_fiscal!=undefined && this.env.pos.config.InnKkm_fiscal!=false){
                InnKkm=this.env.pos.config.InnKkm_fiscal
            }
        var order = self.env.pos.get_order();
        var NotPrint = this.env.pos.config.NotPrint;
        var IsBarCode = this.env.pos.config.IsBarCode;
        var XRep = this.env.pos.config.XRep;
        var ZRep = this.env.pos.config.ZRep;
        var res = this.env.services.rpc({
                    route: '/cashier/info',
                    params: {
                        cashier_id: this.env.pos.get_cashier_user_id(),
                    },
                }, { shadow: true }).then((value) => { CashierName = value['name'];
                                                    CashierVATIN =  value['inn'];
                                                    if (XRep == true) XReport(NumDevice,UrlServer,User,Password,InnKkm);
                                                    if (ZRep == false) CloseShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm);
                                                    if (ZRep == true) ZReport(NumDevice,UrlServer,User,Password,InnKkm);
                                                    }).catch((err) => {
                                                    CashierName = this.env.pos.config.CashierName[1];
                                                    CashierVATIN = this.env.pos.config.CashierVATIN;
                                                    if (XRep == true) XReport(NumDevice,UrlServer,User,Password,InnKkm);
                                                    if (ZRep == false) CloseShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm);
                                                    if (ZRep == true) ZReport(NumDevice,UrlServer,User,Password,InnKkm);
                                                    });
     }
  }

KKM_Close.template = 'KKM_Close';
  ProductScreen.addControlButton({
      component: KKM_Close,
      condition: function () {
            var has_enabled = false;
            if (this.env.pos.config.enable_kkm_server) {
                has_enabled = true;
            }
            return has_enabled;
        },
      position: ['after', 'SetSaleOrderButton'],
  });

  Registries.Component.add(KKM_Close);

  return KKM_Close;

});

function ExecuteCommand(UrlServer,User,Password,
    Data,
    currentOrder,
    FunSuccess,
    FunError,
    timeout) {
    console.log('ExecuteCommand');
    LogJS('info','ExecuteCommand')
    if (FunSuccess === undefined) {
        FunSuccess = ExecuteSuccess;
    }
    if (timeout === undefined) {
        timeout = 60000;
    }
    try {
        if (KkmServer != undefined) {
            if (typeof (Data) == "string") Data = JSON.parse(Data);
            KkmServer.Execute(FunSuccess, Data);
            return;
        };
    } catch { };
    var JSon = JSON.stringify(Data);
    $.support.cors = true;
    var jqXHRvar = $.ajax({
        type: 'POST',
        async: true,
        timeout: timeout,
        url: UrlServer + ((UrlServer == "") ? window.location.protocol + "//" + window.location.host + "/" : "/") + 'Execute',
        crossDomain: true,
        dataType: 'json',
        contentType: 'application/json; charset=UTF-8',
        processData: false,
        data: JSon,
        headers: (User != "" || Password != "") ? { "Authorization": "Basic " + btoa(User + ":" + Password) } : "",
        success: function (Rezult, textStatus, jqXHR) {
            if (Rezult.Status == 0) {
                MessageStatus = "Успешно";
            } else if (Rezult.Status == 1) {
                MessageStatus = "Выполняется";
            } else if (Rezult.Status == 2) {
                MessageStatus = "Ошибка";
            } else if (Rezult.Status == 3) {
                MessageStatus = "Данные не найдены";
            };
            MessageError = Rezult.Error;

            var MessageCheckNumber = Rezult.CheckNumber;
            var MessageSessionNumber = Rezult.SessionNumber;
            var MessageLineLength = Rezult.LineLength;
            var MessageAmount = Rezult.Amount;
            if (currentOrder!=undefined && Rezult.UniversalID!=undefined){
                currentOrder.set_kkm_UniversalID(Rezult.UniversalID);
            }
            // mes = MessageStatus;
            if (MessageError !="" && MessageError!=undefined) {
                alert(MessageStatus+"\nСообщение об ошибке:"+MessageError);
                return;
            }//{mes=mes+"\n Сообщение об ошибке:"+MessageError}
            //if (MessageStatus =="Успешно" && MessageError=="") {mes=""}
        },//FunSuccess,
        error: FunError
    });
        console.log('Ответ ККМ:',jqXHRvar);
        LogJS('warning','Ответ ККМ:' +jqXHRvar)
}

//Обработка возвращаемых данных
function ExecuteSuccess(Rezult, textStatus, jqXHR) {
    console.log('ExecuteSuccess');
    LogJS('info','ExecuteSuccess')
    console.log('Rezult',JSON.stringify(Rezult));
    LogJS('warning','Rezult: '+JSON.stringify(Rezult))
    var ValidationResult;
    if (Rezult.Status == 0) {
        MessageStatus = "Успешно";
        if (Rezult.MarkingCodeValidation!=undefined){
            var i;
            for (i = 0; i < Rezult.MarkingCodeValidation.length; i++) {
                if (Rezult.MarkingCodeValidation[i].ValidationPR.ValidationResult||Rezult.MarkingCodeValidation[i].ValidationPR.ValidationDisabled){
                    console.log('Код маркировки прошел проверку')
                } else {
                    var serverResponse = Rezult.MarkingCodeValidation[i].ValidationPR.DecryptionResult;
                    console.log('Код маркировки НЕ прошел проверку');
                    // попап с ошибкой
                    window.myErrorPopup(serverResponse);
                    // удалить продукт из заказа
                    window.removeCurrentOrderline();
                }
            }
        }
    } else if (Rezult.Status == 1) {
        MessageStatus = "Выполняется";
    } else if (Rezult.Status == 2) {
        MessageStatus = "Ошибка";
    } else if (Rezult.Status == 3) {
        MessageStatus = "Данные не найдены";
    };

    MessageError = Rezult.Error;

    var MessageCheckNumber = Rezult.CheckNumber;
    var MessageSessionNumber = Rezult.SessionNumber;
    var MessageLineLength = Rezult.LineLength;
    var MessageAmount = Rezult.Amount;

    if (MessageError !="" && MessageError!=undefined) {alert(MessageStatus+"\nСообщение об ошибке:"+MessageError)}//{mes=mes+"\n Сообщение об ошибке:"+MessageError}
    //if (MessageStatus =="Успешно" && MessageError=="") {mes=""}
}

//Генерация гуида
function guid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

//Вычисление количества копий чека
function calculateNumberCopies(DoubleReceipt) {
    if (DoubleReceipt == true) {
        numberCopies = 1;
    } else {
        numberCopies = 0;
    }
    return numberCopies;
}

//Открытие смены
function OpenShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm) {
    console.log('OpenShift');
    LogJS('info','OpenShift')
    var Data = {
        Command: "OpenShift",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        CashierName: CashierName,
        CashierVATIN: CashierVATIN,
        NotPrint: NotPrint,
        IdCommand: guid(),
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);
    //if (mes!="")alert("Открытие смены завершилось с сообщением: " + mes);
    //mes="";
}

//Закрытие смены
function CloseShift(NumDevice,CashierName,CashierVATIN,NotPrint,UrlServer,User,Password,InnKkm) {
    console.log('CloseShift');
    LogJS('info','CloseShift')
    var Data = {
        Command: "CloseShift",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        CashierName: CashierName,
        CashierVATIN: CashierVATIN,
        NotPrint: NotPrint,
        IdCommand: guid(),
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);
    //if (mes!="")alert("Закрытие смены завершилось с сообщением: " + mes);
    //mes="";
}

// Печать X отчета
function XReport(NumDevice,UrlServer,User,Password,InnKkm) {
    console.log('XReport');
    LogJS('info','XReport')
    var Data = {
        Command: "XReport",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        IdCommand: guid()
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);
    //if (mes!="")alert("Печать Х-Отчета завершилась с сообщением: " + mes);
    //mes="";
}

// Печать Z отчета
function ZReport(NumDevice,UrlServer,User,Password,InnKkm) {
    console.log('ZReport');
    LogJS('info','ZReport')
    var Data = {
        Command: "ZReport",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        IdCommand: guid()
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);
    //if (mes!="")alert("Печать Z-Отчета завершилась с сообщением: " + mes);
    //mes="";
}

// Печать чека
function RegisterCheck(NumDevice,TypeCheck,IsBarCode,UrlServer,User,Password,order,CashierName,CashierVATIN,InnKkm,DoubleReceipt) {
    console.log('RegisterCheck');
    LogJS('info','RegisterCheck')
    var client = order.get_partner();
    var receipt = order.export_for_printing();
    var orderlines = order.get_orderlines();
    var paymentlines = order.get_paymentlines();
    var Cash = 0;
    var ElectronicPayment = 0;
    for (var i = 0; i < paymentlines.length; i++) {
        if (paymentlines[i].payment_method.type=="cash") {Cash = Cash + Math.abs(paymentlines[i].amount);}
        if (paymentlines[i].payment_method.type=="bank") {ElectronicPayment = ElectronicPayment + Math.abs(paymentlines[i].amount);}
    };
    var products = _.map(order.get_orderlines(), function (line) {return line.product; });
    var quantities = _.map(order.get_orderlines(), function (line) {return line.quantity; });
    var lot = _.map(order.get_orderlines(), function (line) {return line.get_lot_lines(); });
    var prices = _.map(order.get_orderlines(), function (line) {return line.price; });
    var discounts = _.map(order.get_orderlines(), function (line) {return line.discount; });
    var tax_ids = _.map(order.get_orderlines(), function (line) {return line.get_taxes(); });
    var subtotal = _.map(order.get_orderlines(), function (line) {
        return line.price_subtotal_incl;
    });
    var print = [];
    client_email="";
    client_name="";
    client_barcode="";
    if (client!=undefined && client!=null){
        if (client.email!=undefined && client.email!=null){client_email=client.email;}
        if (client.name!=undefined && client.name!=null){client_name=client.name;}
        if (client.barcode!=undefined && client.barcode!=null){client_barcode=client.barcode;}
    }
    for (var i = 0; i < products.length; i++) {
        if (lot[i] !== false) {
            GoodCodeDataContent = {
                BarCode: lot[i][0].lot_name,
                ContainsSerialNumber: true,
                AcceptOnBad: false,
            }
        } else {
            GoodCodeDataContent = {
            BarCode: products.barcode,
            ContainsSerialNumber: false,
            AcceptOnBad: false,
        }}
        console.log('GoodCodeDataContent',GoodCodeDataContent);
        if (quantities[i]!=0){
            var Amount = (quantities[i]*prices[i]).toFixed(2); //(quantities[i]*prices[i]*(100-discounts[i])/100).toFixed(2);
            if (discounts[i]!=undefined && discounts[i]!=null && discounts[i]!=0){
                Amount = (quantities[i]*prices[i]*(100-discounts[i])/100).toFixed(2);
    //            alert(quantities[i])
    //            alert(prices[i])
    //            alert(discounts[i])
    //            alert(Amount)
            }
            var Department = 0;
            var Tax = -1;
            var tax_id = 0
            if (tax_ids.length>0 && tax_ids[i].length>0){tax_id=tax_ids[i][0].amount}
            if (tax_id == 10){Tax=10}
            if (tax_id == 20){Tax=20}
            var SignMethodCalculation = 4;
            var SignCalculationObject = 1;
                var T = { PrintText: { Text: "<<->>" }, };
            var P = {
                Register: {
                    Name: products[i].display_name,
                    Quantity: Math.abs(quantities[i]),
                    Price: Math.abs(prices[i]),
                    Amount: Math.abs(Amount),
                    Department: Department,
                    Tax: Tax,
                    EAN13: products[i].barcode,
                    SignMethodCalculation: SignMethodCalculation,
                    SignCalculationObject: SignCalculationObject,
                    //MeasurementUnit: "шт",//products[i].display_name ,
                    GoodCodeData: GoodCodeDataContent,
                },
                BarCode: {
                    BarcodeType: "EAN13" ,
                    Barcode: products[i].barcode,
                    },
                };
                print.push(T);
                print.push(P);
        }
        };
    var RRNCode = ""
    var AuthorizationCode = ""
    if (order.pay_cancel_kkm_guid!=undefined && order.pay_cancel_kkm_guid!=false && order.pay_cancel_kkm_guid!=null){
        //alert('TUT')
         var arrayUniversalIDRefund = order.UniversalIDRefund.split(';')
         arrayUniversalIDRefund.forEach(function(item, i, arr) {
            var UniversalIDRefundItem = item.split(':')
            if (UniversalIDRefundItem[0]==='RRN') RRNCode = UniversalIDRefundItem[1]
            if (UniversalIDRefundItem[0]==='AC') AuthorizationCode = UniversalIDRefundItem[1]
            //alert(UniversalIDRefundItem[0] + '---' + UniversalIDRefundItem[1])
            //alert( i + ": " + item + " (массив:" + arr + ")" );
         });
    }
    //alert('RRNCode: ' + RRNCode)
    //alert('AuthorizationCode: ' + AuthorizationCode)
    var Data = {
        Command: "RegisterCheck",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        KktNumber: "",
        Timeout: 30,
        IdCommand: guid(),
        IsFiscalCheck: true,
        TypeCheck: TypeCheck,
        NotPrint: false,
        NumberCopies: calculateNumberCopies(DoubleReceipt), // подставляет кол-во копий чека (0 или 1)
        CashierName: CashierName,
        CashierVATIN: CashierVATIN,
        ClientAddress: client_email,
        ClientInfo: client_name,
        ClientINN: client_barcode,
        SenderEmail: "",
        PlaceMarket: "",
        TaxVariant: "",
        PayByProcessing: false,
        NumDeviceByProcessing : null,
        ReceiptNumber: order.name,
        PrintSlipAfterCheck: false,
        PrintSlipForCashier: true,
        //Если это чек возврата то возможны два поля для отмены транзакции (если не указано то по эквайрингу будет не отмена а возврат оплаты)
        RRNCode: RRNCode, // RRNCode из операции эквайринга. Только для отмены оплаты! Для Оплаты или возврата оплаты не заполнять!
        AuthorizationCode: AuthorizationCode, // AuthorizationCode из операции эквайринга. Только для отмены оплаты! Для Оплаты или возврата оплаты не заполнять!
        CheckStrings: print,
        Cash: Cash.toFixed(2),
        ElectronicPayment: ElectronicPayment.toFixed(2),
        //AdvancePayment: 0,
        //Credit: 0,
        //CashProvision: 0,
    };

    if (IsBarCode == false) {
        for (var i=0; i < Data.CheckStrings.length; i++) {
            if (Data.CheckStrings[i] != undefined && Data.CheckStrings[i].BarCode != undefined) {
                Data.CheckStrings[i].BarCode = null;
            };
            if (Data.CheckStrings[i] != undefined && Data.CheckStrings[i].PrintImage != undefined) {
                Data.CheckStrings[i].PrintImage = null;
            };
        };
    };

    
    Data.AgentSign = null;
    Data.AgentData = null;
    Data.PurveyorData = null;
    for (var i = 0; i < Data.CheckStrings.length; i++) {
        if (Data.CheckStrings[i] != undefined && Data.CheckStrings[i].Register != undefined) {
            Data.CheckStrings[i].Register.AgentSign = null;
            Data.CheckStrings[i].Register.AgentData = null;
            Data.CheckStrings[i].Register.PurveyorData = null;
        };
    };
    console.log('Data',JSON.stringify(Data));
    LogJS('warning','Data: '+JSON.stringify(Data))
    ExecuteCommand(UrlServer,User,Password,Data);
} 

function LogJS(Level, Message) {
    glSelf.env.services.rpc({
        route: '/loggerjs/message',
        params: {
            Level: Level,
            Message: Message,
        },
    }, { shadow: true }).then((value) => { console.log(value);
                                        }).catch((err) => {console.log(err);
                                        });
}
